require "import"
import "android.app.*"
import "android.os.*"
import "android.widget.*"
import "android.view.*"
import "layout"
--activity.setTitle('AndroLua+')
--activity.setTheme(android.R.style.Theme_Holo_Light)
--activity.setContentView(loadlayout(layout))
import "android.content.Intent"
import "android.speech.tts.TextToSpeech"
import "android.content.pm.PackageManager"
import "android.content.pm.ApplicationInfo"
import "android.speech.tts.UtteranceProgressListener"

function reloadInstalledTtsEngines()
  local results={}
  local pm=activity.getPackageManager()
  local intent = Intent(TextToSpeech.Engine.INTENT_ACTION_TTS_SERVICE)
  local resolveInfos = pm.queryIntentServices(intent, PackageManager.MATCH_DEFAULT_ONLY);
  for k,resolveInfo ipairs(luajava.astable(resolveInfos))
    local serviceInfo = resolveInfo.serviceInfo;
    local appInfo = serviceInfo.applicationInfo;
    local packageName = serviceInfo.packageName;
    local title = resolveInfo.loadLabel(pm);
    local isSystemApp = ((appInfo.flags & ApplicationInfo.FLAG_SYSTEM) != 0);
    table.insert(results,title.."/"..packageName);
  end
  return results;
end

local ts=reloadInstalledTtsEngines()
--print(dump(ts))

local i=0
function ff()
  task(1000,function()
    i=i+1
    local v=ts[i]
    if v==nil then
      print("测试完毕")
      return
    end
    local n,p=v:match("^([^/]+)/(.+)$")
    --print(n,p)
    local t=0
    tts=TextToSpeech(activity,function(...)
      --print(n,p,tts.getCurrentEngine())
      print(n,"正在测试")
      if p~=tts.getCurrentEngine()
        print(p,"加载出错")
        return
      end
      local t=System.currentTimeMillis()
      local b=true
      tts.setOnUtteranceProgressListener(UtteranceProgressListener{
        onStart=function ( utteranceId)
        end,
        onDone=function ( utteranceId)
          tts.shutdown()
        end,
        onError=function ( utteranceId)
          print("测试出错")
        end,
        onBeginSynthesis=function ( utteranceId, sampleRateInHz, audioFormat, channelCount)
          print("音质", sampleRateInHz);
        end,
        onAudioAvailable=function ( utteranceId, audio)
          if b then
            print("响应速度",System.currentTimeMillis()-t,"毫秒")
          end
          b=false
          --print(utteranceId, audio);
        end,
        onStop=function ( utteranceId, interrupted)
          print(utteranceId, interrupted);
        end
      })
      tts.speak("正在测试",0,nil,"")
    end,p)
    ff()
  end)
end
ff()